/*
Copyright 2002 - 2004 UnitedAdmins
Project originally created by OLO (http://olo.counter-strike.pl)

This file is part of StatsMe.

   StatsMe is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   StatsMe is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with StatsMe; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   A copy of the GNU General Public License is available in a file called COPYING.
   See README for more information.

*/

/* $Id: statsme_tfc.cpp,v 1.18 2004/03/18 10:44:55 punisher Exp $ */

#include <extdll.h>			// always
#include <sdk_util.h>		// REG_SVR_COMMAND, etc
#include <meta_api.h>		// Plugin_info, etc
#include <cbase.h>			// DMG bits
#include "statsme.h"	// me


/*void SetModel_TFC(edict_t *e, const char *m){
	//this entity has an owner (grenade?) and the model is from CS grenade
	
	if (e->v.owner)
	{
		printf("SETTING: %s %s FOR: %s\n",m,STRING(e->v.classname),STRING(e->v.owner->v.netname));
	}


	if(e->v.owner&&m[7]=='p'&&m[8]=='i'&&m[9]=='p') {   // pipebomb from grenadelauncher
		player_t*pPlayer = GET_PLAYER_POINTER(e->v.owner);
		PutMissile(e, 12, pPlayer);
		FireShot(pPlayer, 12);
	}
	if(e->v.owner&&m[7]=='r'&&m[8]=='p'&&m[9]=='g') {   // rocket from rpg or nails from ng /superng
		player_t*pPlayer = GET_PLAYER_POINTER(e->v.owner);
		int weapon = 10;
		switch (pPlayer->class_index) {
		case PC_SCOUT:
			weapon = 10;
		case PC_MEDIC:
			weapon = 11;
		case PC_SOLDIER:
			weapon = 14;
		}
		FireShot(pPlayer,weapon);
	} 
	if(e->v.owner&&m[7]=='w'&&m[8]=='_'&&m[9]=='g'&&m[10]=='r'&&m[11]=='e') {	// normalgrenade
		player_t*pPlayer = GET_PLAYER_POINTER(e->v.owner);
		PutMissile(e,30,pPlayer);
		FireShot(pPlayer,30);
	}
	RETURN_META(MRES_IGNORED);
} */


void Client_Suicide(stat_t* a)
{
	a->deaths+=2;
}


// message about death (top-right corner)
void Client_DeathMsg_TFC(void* mValue)
{	
	static player_t *killer;
	static player_t *victim;
	static int kid;
	static int vid;
	int hs = 0;

	switch (mState++){
	case 0:
		kid = *(int*)mValue;
		killer = sm.killer = (kid > 0 && kid < 33) ? GET_PLAYER_POINTER_I(kid) : NULL;
		break;
	case 1:
		vid = *(int*)mValue;
		victim = sm.victim = (vid > 0 && vid < 33) ? GET_PLAYER_POINTER_I(vid) : NULL;
		break;
	case 2:	
		//only if attacker and victim are valid and it's not the same player

		if (  !killer || !victim )
			break;

		if (  killer->index == victim->index )  { // enforce penalty for suicides...
				victim->pRnd_stats->deaths++;
				victim->pGm_stats->deaths++;
				victim->pRnd_stats->sk++;
				victim->pGm_stats->sk++;
				break;
		}
		
		victim->damage_deathmsg = 0;

		const char* sWpn = (char*)mValue;

		if (sWpn[0]=='r'&&sWpn[1]=='o'&&sWpn[2]=='c') //this is rocket from rpg
			sWpn = "rpg";
		else if (sWpn[0]=='g'&&sWpn[1]=='l'&&sWpn[2]=='_') // this is gl_grenade from gl
			sWpn = "gl";
		else if (sWpn[0]=='p'&&sWpn[1]=='i'&&sWpn[2]=='p') // this is pipebomb from pl
			sWpn = "pl";
		else if (sWpn[0]=='n'&&sWpn[1]=='a'&&sWpn[2]=='i'&&sWpn[4]=='s') // this is nail from ng
			sWpn = "ng";
		else if (sWpn[5]=='n'&&sWpn[6]=='a'&&sWpn[7]=='i') // this is supernail from superng
			sWpn = "superng";
		else if (sWpn[0]=='f'&&sWpn[1]=='l'&&sWpn[2]=='a') // this is flames from flamethrower
			sWpn = "flamethrower";
		else if (sWpn[0]=='h'&&sWpn[1]=='e'&&sWpn[2]=='a') { // this is headshot
			sWpn = "sniperrifle";
			hs = 1;
			}
		else if ((sWpn[0]=='c'&&sWpn[1]=='a'&&sWpn[2]=='l')||(sWpn[1]=='a'&&sWpn[2]=='p')||(sWpn[0]=='g'&&sWpn[1]=='a')||(sWpn[0]=='n'&&sWpn[4]=='g')||(sWpn[0]=='m'&&sWpn[1]=='i')||(sWpn[0]=='e'&&sWpn[1]=='m'))
			sWpn = "classgrenade";
		
		for (int i = 0; i < MAX_WEAPONS ; ++i) {
			if ( strcmp( sWpn, weapon_select[i].name ) )
				continue;

		strcpy(killer->pPpl_stats[vid].name, weapon_select[i].name); //save name of weapon from which you have been killed
		strcpy(victim->pAPpl_stats[kid].name, weapon_select[i].name);
		
		strcpy(killer->pWpn_stats[i].name , weapon_select[i].name ); //save name of this weapon

		killer->custom = &killer->pPpl_stats[vid];
		victim->custom = &victim->pPpl_stats[kid];
		victim->killer = killer;
		killer->victim = victim;
		victim->damage_deathmsg = hs + 1; //deathmessage with headshot

		mPlayer = victim;

		FireKill(victim, killer, i, hs , (killer->team_index == victim->team_index) );
		
		endfunction = Client_SM_DeathMsg;

		break;
		}
	}
}

// msg send when player requests list of weapons from server
void Client_WeaponList_TFC(void* mValue)
{
	static int wpnList;
	static int iId;
	static int iSlot;
	static const char* wpn_name;	
	
	switch (mState++) {
	case 0:
		wpn_name = (char*)mValue;
		break;
	case 1:
		iSlot = *(int*)mValue;
		break;
	case 7:
		iId = *(int*)mValue;

		if ( ( iId < MAX_WEAPONS ) && ( wpnList & (1<<iId) ) ) //check if weapon is not already listed
			break;

		wpnList |= (1<<iId);

		weapon_select[iId].iId = iId;
		//const char* new_wpn_name = strstr(wpn_name,"tf_weapon_");
		//if ( new_wpn_name && *new_wpn_name )
		strcpy(weapon_select[iId].name, ( wpn_name + 10 ) ); //trunk "tf_weapon_" from weapon name
	
		iId = 31;
		weapon_select[iId].iId = iId;
		strcpy(weapon_select[iId].name , "sentrygun");

		iId = 30;
		weapon_select[iId].iId = iId;
		strcpy(weapon_select[iId].name , "normalgrenade");

		iId = 29;
		weapon_select[iId].iId = iId;
		strcpy(weapon_select[iId].name , "classgrenade");

	}
	
} 

/*
// message send when player takes damage
void Client_Damage_TFC(void* mValue)
{
	static int damage;
	static int bits;

	switch (mState++) {
	case 1:	
		damage = *(int*)mValue;
		break;
	case 2:
		bits = *(int*)mValue;
		break;
	case 3:

		if (!damage) //|| !*(float*)mValue ) // || bits)
			break; //no damage or this is just a fall or this is dmg not from bullets/grenade

		edict_t *enemy = NULL;

		if ( (enemy = mPlayer->pEdict->v.dmg_inflictor) == NULL )
			break; //no enemy

		player_t *killer = NULL;
		grenades_t* grenade = NULL;
		int weapon = 0;
		int aiming = 0;
		
		if (enemy->v.flags & player_bits) { // player
			killer = GET_PLAYER_POINTER(enemy);
			weapon = killer->weapon->id;
			aiming = killer->aiming_at;
		}
		else if( ( grenade = FindGrenade(enemy) ) != NULL ) { //grenade
			killer = grenade->owner;
			weapon = grenade->weapon;
			// LOG_MESSAGE(PLID,UTIL_VarArgs("Grenade Damage from %s (%d) found",killer->name,killer->index));
		}
		else //no grenade nor player so skip it
		{
			break;
		}

		if (killer) {//if this is a player

			// this is for SM_Damage_CS
			mPlayer->damage_aim = aiming;
			mPlayer->damage_attacker = killer;
			mPlayer->damage_damage = damage;
			mPlayer->damage_weapon = weapon;

			// end

			FireHit(mPlayer,killer, weapon, damage, aiming);

			// send SM_DeathMsg or SM_Damage and then SM_DeathMsg
			endfunction = mPlayer->damage_deathmsg ? Client_SM_DeathMsg : Client_SM_Damage;

			sm.killer = killer;
			sm.victim = mPlayer;
		}
	} 
} */

/*// msg send to update current status about weapon - ammo, active weapon etc
void Client_CurWeapon_TFC(void* mValue)
{
	static int iState;
	static int iId;

	switch (mState++){
	case 0:	
		iState = *(int*)mValue;
		break;
	case 1:
		if (!iState)
			break;//active weapon have iState set to 1
			
		iId = *(int*)mValue; // weapon ID
		break;
	case 2:
		if (!iState) break;
		
		int iClip = *(int*)mValue;
		
		if (iClip > -1 && iClip < mPlayer->pWpn_stats[iId].clip) 
		{
			FireShot(mPlayer, iId);
		}
		
		mPlayer->weapon = &mPlayer->pWpn_stats[iId];
		mPlayer->weapon->id = iId;
		strcpy(mPlayer->weapon->name, weapon_select[iId].name); //save name of this weapon
		mPlayer->pWpn_stats[iId].clip = iClip;
	}
} */

/*void Client_InitHUD_TFC(void* mValue)
{

}*/

/*
// message gets sent when the players health changes
void Client_Health_TFC(void* mValue)
{
	int health = *(int*)mValue;
	int damage = mPlayer->health - health;
	mPlayer->health = health;
	if ( damage <= 0 ) return;
	edict_t* enemy = NULL;
	player_t* killer = NULL;
	grenades_t* grenade;
	int weapon = 0;
	int aiming = 0;

	if ( (enemy = mPlayer->pEdict->v.dmg_inflictor) == NULL )
		return; //no enemy
	
	if (enemy->v.flags & player_bits) { // player
		killer = GET_PLAYER_POINTER(enemy);
		weapon = killer->weapon->id;
		aiming = killer->aiming_at;
	}
	else if( ( grenade = FindGrenade(enemy) ) != NULL ) { //grenade
		killer = grenade->owner;
		weapon = grenade->weapon;
	}
	else {//no grenade nor player so skip it
		return; 
	}

	if (killer) {//if this is a player
		// this is for SM_Damage_CS
		mPlayer->damage_aim = killer->aiming_at;
		mPlayer->damage_attacker = killer;
		mPlayer->damage_damage = damage;
		mPlayer->damage_weapon = weapon;
		// end

		if (weapon > 0 && weapon < 3) // german and american knife
			FireShot(killer, weapon);

		FireHit(mPlayer,killer, weapon, damage, aiming);
		// send SM_DeathMsg or SM_Damage and then SM_DeathMsg
		endfunction = mPlayer->damage_deathmsg ? Client_SM_DeathMsg : Client_SM_Damage;
		sm.killer = killer;
		sm.victim = mPlayer;
	}	
} 
*/

void Client_ScoreInfo_TFC(void* mValue)
{
	if (mPlayer) return;
	player_t*pPlayer;
	static int index;
	static int class_index;
	switch (mState++) {
	case 0:
		index = *(int*)mValue;
		break;
	case 3:
		class_index = *(int*)mValue;
		break;
	case 4:
		pPlayer = GET_PLAYER_POINTER_I(index);
		pPlayer->class_index = class_index;
		pPlayer->team_index = *(int*)mValue;
		strcpy(pPlayer->team_name, sm.team_name[*(int*)mValue]);
		// LOG_MESSAGE(PLID,UTIL_VarArgs("ScoreInfo : %s  |  Team : %d  | Class : %d ",pPlayer->name,pPlayer->team_index,pPlayer->class_index));
	}
}
